def is_cube_valid(numbers):
  """
  Проверяет, можно ли из заданного набора чисел составить правильный игральный кубик.

  Args:
    numbers (list): список из шести чисел.

  Returns:
    bool: True, если можно составить правильный кубик, иначе False.
  """

  # Проверяем, что все числа разные.
  if len(set(numbers)) != 6:
    return False

  # Проверяем, что суммы чисел на противоположных гранях одинаковы.
  for i in range(3):
    if numbers[i] + numbers[5 - i] != numbers[i + 1] + numbers[4 - i]:
      return False

  return True


def main():
  """
  Запрашивает у пользователя наборы чисел и проверяет, можно ли из них составить правильные кубики.
  """

  while True:
    # Запрашиваем у пользователя набор чисел.
    numbers = [int(x) for x in input("Введите набор чисел: ").split()]

    # Проверяем, можно ли из заданного набора чисел составить правильный кубик.
    if is_cube_valid(numbers):
      print("Можно составить правильный кубик.")
    else:
      print("Нельзя составить правильный кубик.")

    # Спрашиваем у пользователя, хочет ли он продолжить.
    if input("Хотите продолжить? (y/n) ") == "n":
      break


if __name__ == "__main__":
  main()
