def lunar_add(a, b):
    """Сумма в лунной арифметике."""
    a_str = str(a)
    b_str = str(b)
    max_len = max(len(a_str), len(b_str))
    a_str = a_str.zfill(max_len)
    b_str = b_str.zfill(max_len)
    result = ""
    for i in range(max_len):
        result += str(max(int(a_str[i]), int(b_str[i])))
    return int(result)


def lunar_multiply(a, b):
    """Произведение в лунной арифметике."""
    a_str = str(a)
    b_str = str(b)
    len_a = len(a_str)
    len_b = len(b_str)
    result = 0
    for i in range(len_a):
        for j in range(len_b):
            digit_a = int(a_str[len_a - 1 - i])
            digit_b = int(b_str[len_b - 1 - j])
            result = lunar_add(result, min(digit_a, digit_b) * (10**(i + j)))
    return result


a = int(input())
b = int(input())

sum_result = lunar_add(a, b)
product_result = lunar_multiply(a, b)

print(f"{sum_result} {product_result}")