from collections import deque, defaultdict

def find_protected_storages(n, m, roads, k, guards):
    # Построение графа
    graph = defaultdict(list)
    
    for a, b in roads:
        graph[a].append(b)
        graph[b].append(a)
    
    protected_storages = set()
    
    # Обработка каждого охранника
    for p, h in guards:
        visited = set()
        queue = deque([(p, 0)])  # (текущий склад, текущее расстояние)
        
        while queue:
            current_storage, distance = queue.popleft()
            
            if distance > h:
                continue
            
            # Добавляем склад в защищенные
            protected_storages.add(current_storage)
            visited.add(current_storage)
            
            # Добавляем соседей в очередь
            for neighbor in graph[current_storage]:
                if neighbor not in visited:
                    queue.append((neighbor, distance + 1))
    
    return sorted(protected_storages)  # Возвращаем отсортированный список охраняемых складов

# Пример использования
n = 5  # количество складов
m = 4  # количество дорог
roads = [(1, 2), (2, 3), (2, 4), (3, 5)]  # дороги между складами
k = 2  # количество охранников
guards = [(1, 1), (4, 1)]  # (номер склада охранника, запас выносливости)

protected_storages = find_protected_storages(n, m, roads, k, guards)
print("Охраняемые склады:", protected_storages)
from collections import deque, defaultdict

def find_protected_storages(n, m, roads, k, guards):
    # Построение графа
    graph = defaultdict(list)
    
    for a, b in roads:
        graph[a].append(b)
        graph[b].append(a)
    
    protected_storages = set()
    
    # Обработка каждого охранника
    for p, h in guards:
        visited = set()
        queue = deque([(p, 0)])  # (текущий склад, текущее расстояние)
        
        while queue:
            current_storage, distance = queue.popleft()
            
            if distance > h:
                continue
            
            # Добавляем склад в защищенные
            protected_storages.add(current_storage)
            visited.add(current_storage)
            
            # Добавляем соседей в очередь
            for neighbor in graph[current_storage]:
                if neighbor not in visited:
                    queue.append((neighbor, distance + 1))
    
    return sorted(protected_storages)  # Возвращаем отсортированный список охраняемых складов

# Пример использования
n = 5  # количество складов
m = 4  # количество дорог
roads = [(1, 2), (2, 3), (2, 4), (3, 5)]  # дороги между складами
k = 2  # количество охранников
guards = [(1, 1), (4, 1)]  # (номер склада охранника, запас выносливости)

protected_storages = find_protected_storages(n, m, roads, k, guards)
print("Охраняемые склады:", protected_storages)