from collections import deque, defaultdict

def find_guarded_warehouses(n, m, roads, k, guards):
    # Построение графа
    graph = defaultdict(list)
    for a, b in roads:
        graph[a].append(b)
        graph[b].append(a)

    guarded = set()

    # Обход для каждого охранника
    for p, h in guards:
        queue = deque([(p, 0)])  # (текущий склад, текущее расстояние)
        visited = set()
        visited.add(p)

        while queue:
            current, distance = queue.popleft()
            if distance > h:
                continue
            guarded.add(current)

            for neighbor in graph[current]:
                if neighbor not in visited:
                    visited.add(neighbor)
                    queue.append((neighbor, distance + 1))

    return sorted(guarded)

# Пример использования
n = 5  # количество складов
m = 4  # количество дорог
roads = [(1, 2), (2, 3), (3, 4), (4, 5)]  # дороги
k = 2  # количество охранников
guards = [(1, 2), (3, 1)]  # охранники (склад, выносливость)

guarded_warehouses = find_guarded_warehouses(n, m, roads, k, guards)
print(guarded_warehouses)  # Вывод охраняемых складов