from collections import deque, defaultdict

def find_guarded_warehouses(n, m, roads, k, guards):
    # Построение графа
    graph = defaultdict(list)
    for a, b in roads:
        graph[a].append(b)
        graph[b].append(a)

    # Массив для хранения охраняемых складов
    guarded = [False] * (n + 1)

    # Поиск для каждого охранника
    for p_i, h_i in guards:
        queue = deque([(p_i, 0)])  # (текущий склад, текущее расстояние)
        visited = set()
        visited.add(p_i)

        while queue:
            current, distance = queue.popleft()
            if distance > h_i:
                continue
            guarded[current] = True  # Отметить склад как охраняемый

            for neighbor in graph[current]:
                if neighbor not in visited:
                    visited.add(neighbor)
                    queue.append((neighbor, distance + 1))

    # Сбор охраняемых складов
    result = [i for i in range(1, n + 1) if guarded[i]]
    return result

# Пример использования
n = 5  # количество складов
m = 4  # количество дорог
roads = [(1, 2), (2, 3), (3, 4), (4, 5)]  # дороги
k = 2  # количество охранников
guards = [(1, 2), (3, 1)]  # охранники (склад, выносливость)

guarded_warehouses = find_guarded_warehouses(n, m, roads, k, guards)
print(guarded_warehouses)  # Вывод охраняемых складов