from collections import deque, defaultdict

# Ввод данных
n, m, k = map(int, input().split())


# Создание графа
graph = defaultdict(list)

# Чтение дорог
for _ in range(m):
    a, b = map(int, input().split())
    graph[a].append(b)
    graph[b].append(a)

# Множество для хранения охраняемых складов
guarded_warehouses = set()

# Чтение охранников и выполнение BFS
for _ in range(k):
    p, h = map(int, input().split())
    
    # BFS для нахождения охраняемых складов от текущего охранника
    queue = deque([(p, 0)])  # Склад и текущее расстояние
    visited = set([p])        # Множество посещенных складов

    while queue:
        current_warehouse, distance = queue.popleft()
        guarded_warehouses.add(current_warehouse)

        if distance < h:  # Можно двигаться дальше, если не исчерпана выносливость
            for neighbor in graph[current_warehouse]:
                if neighbor not in visited:
                    visited.add(neighbor)
                    queue.append((neighbor, distance + 1))

# Формирование результата
guarded_warehouses = sorted(guarded_warehouses)
print(len(guarded_warehouses))
if guarded_warehouses:
    print(' '.join(map(str, guarded_warehouses)))
else:
    print()