from collections import deque, defaultdict

def main():
    # Чтение входных данных
    n, m, k = map(int, input().split())

    # Построение графа
    graph = defaultdict(list)
    for _ in range(m):
        a, b = map(int, input().split())
        graph[a].append(b)
        graph[b].append(a)

    # Множество для хранения охраняемых складов
    guarded_warehouses = set()

    # Чтение информации об охранниках
    for _ in range(k):
        p, h = map(int, input().split())
        
        # BFS для нахождения всех охраняемых складов от охранника
        queue = deque([(p, 0)])  # Храним кортеж (номер склада и расстояние)
        visited = set([p])        # Список посещенных складов

        while queue:
            current_warehouse, distance = queue.popleft()
            guarded_warehouses.add(current_warehouse)

            if distance < h:  # Если охранник еще может двигаться
                for neighbor in graph[current_warehouse]:
                    if neighbor not in visited:
                        visited.add(neighbor)
                        queue.append((neighbor, distance + 1))
    
    # Формирование результата
    guarded_warehouses = sorted(guarded_warehouses)
    print(len(guarded_warehouses))
    if guarded_warehouses:
        print(' '.join(map(str, guarded_warehouses)))
    else:
        print()

if __name__ == "__main__":
    main()