from collections import deque, defaultdict

def find_guarded_warehouses(n, m, k, roads, guards):
    graph = defaultdict(list)
    
    # Построение графа
    for a, b in roads:
        graph[a].append(b)
        graph[b].append(a)
    
    guarded_warehouses = set()
    
    # Для каждого охранника выполняем обход в ширину
    for p, h in guards:
        queue = deque([(p, 0)])  # (номер склада, текущая дистанция)
        visited = set()
        visited.add(p)
        
        while queue:
            current_warehouse, current_distance = queue.popleft()
            if current_distance <= h:
                guarded_warehouses.add(current_warehouse)
                
                for neighbor in graph[current_warehouse]:
                    if neighbor not in visited:
                        visited.add(neighbor)
                        queue.append((neighbor, current_distance + 1))
    
    # Подготовка результата
    guarded_list = sorted(guarded_warehouses)
    return len(guarded_list), guarded_list

# Чтение входных данных
n, m, k = map(int, input().split())
roads = [tuple(map(int, input().split())) for _ in range(m)]
guards = [tuple(map(int, input().split())) for _ in range(k)]

# Поиск охраняемых складов
count, guarded_warehouses = find_guarded_warehouses(n, m, k, roads, guards)

# Вывод результата
print(count)
print(" ".join(map(str, guarded_warehouses)))